    IMPORTANT: CE README EST SOUS FORMAT MARKDOWN.


 * $Auteur: Loïc DUBARD $
 * $Date: 15/12/2018 $
 *
 * ==================================================================== 
 *
 *


//////////////////////////////////////////////////////////////////////////////////

README du projet de programmation impérative 2018/2019                

//////////////////////////////////////////////////////////////////////////////////




    IMPORTANT: LIRE CE FICHIER AVANT DE LANCER LE PROGRAMME



  Sommaire
==================================================================================

1. Contexte
2. Fonctionnement
3. Conseils d'utilisation

**********************************************************************************

# 1. Contexte              
==================================================================================

Le but de ce projet est d'implanter un jeu d'échecs modifiés, Stackchess.

Dans cette version modifiée du jeu d'échecs, il est possible d'empiler les pièces d'une même couleur sur les cases. À chaque tour, un joueur peut déplacer un nombre quelconque de pièces situées sur le haut de la pile d'une même case. Néanmoins, le déplacement doit être légal pour chacune de pièces déplacées. Par ailleurs, il ne suffit pas de se déplacer sur une case contenant une pièce adverse pour la prendre ; il faut déplacer un nombre de pièces strictement supérieur à celui des pièces adverses dans la case atteinte.

Le but du jeu n'est plus de prendre le roi de l'adversaire, mais de prendre toutes ses pièces. En particulier, il ne sera pas obligatoire pour un joueur de sortir d'une situation d'échec (cas où le roi du joueur peut être pris le tour suivant).
 

Développée par :
- Loïc DUBARD <loic.dubard@ensiie.fr>

# 3. Fonctionnement
===================================================================================

On joue sur un plateau de taille n×n. Par défaut, n vaudra 6, mais une extension décrite ci-dessous indique comment généraliser ceci.

On utilisera les pièces suivantes, dont on rappelle les mouvements légaux :

### Roi (notation R)
peut bouger d'une case verticalement, horizontalement ou en diagonale.

### Dame (notation D)
peut bouger d'un nombre quelconque de cases verticalement, horizontalement ou en diagonale.

### Fou (notation F)
peut bouger d'un nombre quelconque de cases en diagonale.

### Tour (notation T)
peut bouger d'un nombre quelconque de cases verticalement ou horizontalement.

### Pion (notation P)

- si la case visée ne contient pas de pièce adverse : peut bouger d'une case en direction de l'adversaire, de deux si le pion n'a pas encore bougé de la partie.

- si la case visée contient au moins une pièce adverse : peut bouger d'une case en diagonale en direction de l'adversaire.

- Quand des pièces arrivent sur la dernière rangée, les pions arrivés deviennent des dames.

### Cavalier(notation C)

- se déplacent en L: une case verticalement et deux cases horizontalement, ou deux cases verticalement et une case horizontalement.

- peuvent « porter » une autre pièce : si on déplace deux pièces dont un cavalier, alors les deux pièces pourront se déplacer en L quelle que soit l'autre.

On ne peut pas sauter par dessus une pièce (mais on peut se placer dessus si elle est de la même couleur). 

# 3. Conseils d'utilisation
==================================================================================

Le rapport du projet se trouve à "doc/rapport.pdf" et les fichiers sources (.c et .h) se trouvent dans le répertoire "src".

Voici différentes commandes qui vont permettrons de compiler et de jouer au jeu Stackchess en mode console :


**Entrez dans votre console** : 
> make && build/stackchess

**ou sinon :** : 
> make play

**Pour compiler le jeu pour windows :** 
 Pour créer des executables windows (sous linux) vous devez installer le compilateur cross-platform mingw :

> sudo apt-get install mingw-w64
> make all


L'affichage se compose de deux parties : à gauche, le plateau de jeu vu de dessus (on ne voit donc que les pièces au sommet des piles) ; à droite, les coordonnées et le contenu de la pile de pièces sur une case sélectionnée.

En dessous du tableau se trouve une ligne indiquant de quel joueur c'est le tour, et un invite de choix d'action.

À son tour, un joueur entre les coordonnées d'une case (par exemple C5). L'affichage se met à jour en mettant à droite le contenu de la case qui vient d'être sélectionnée. Le joueur peut alors entrer une lettre pour effectuer les actions suivantes :

- avec c on change la case sélectionnée. Il faut alors entrer de nouvelles coordonnées, l'affichage est remis à jour et le joueur recommence à entrer une lettre.
    
- avec d on déplace des pièces depuis la case sélectionnée. On vérifie qu'il y a au moins une pièce sur cette case et qu'elle appartient bien au joueur dont c'est le tour. Si c'est le cas, le joueur entre un nombre de pièces à déplacer ; ce nombre doit être compris entre 1 et le nombre de pièces sur la case. Le joueur entre ensuite la coordonnée cible. Si le déplacement est légal, il est effectué, et les pièces adverses sont prises le cas échéant. Si le déplacement n'est pas possible, un message d'erreur informatif est affiché et le joueur recommence à entrer une lettre.
    
- avec a le joueur abandonne la partie. 

L'affichage est rafraîchi après chaque déplacement, et on change de joueur.


                                



*********************************************************************************************


*Merci pour votre lecture !*

**Loïc Dubard**
