#include"tableau.h"
#include"affichage.h"
#include"deplacement.h"
#include<stdlib.h>
#include<math.h>
//#include<unistd.h>
/*deplacement.c*/

void deplacement(pile **tableau, int N, char *sel, int *tour,int ansi)
{
  if (*sel != '\0'){
    int i,j;
    determiner_indices(sel,N,&i,&j);
    if (i>=N || i<0 || j>=N || j<0)
      printf("\nCase sélectionnée hors du tableau.");
    else if (sommet(tableau[i][j])[1] == "BN"[*tour%2]){
      affichage(tableau,N,sel,*tour,"Combien de pions à déplacer >",ansi);
      int nb=nb_a_selectionner(tableau,i,j,tour);
      if (nb>0){
        int i_dest,j_dest; 
        affichage(tableau,N,sel,*tour,"Entrez les coordonnées de la case de destination>",ansi);
        case_destination(tableau,N,i,j,&i_dest,&j_dest,nb,tour);
      }
    } else 
      printf("\nDéplacement non autorisé");
    printf("\n");
    getchar();
    viderbuffer();
  }
}


int nb_a_selectionner(pile **tableau,int i,int j,int *tour)
{
  int nb;
  scanf("%d",&nb);
  if (nb<=nb_de_piece(tableau[i][j],"BN"[*tour%2]) && nb>0)
    return nb;
  else
    printf("\nVous n'avez pas rentré un nombre valide.");
  return 0;
}

void case_destination(pile **tableau,int N,int i_src,int j_src, int *i_dest,int *j_dest,int nb,int *tour)
{
  char dest[4]="\0\0\0\0";
  scanf("%3s",dest);
  if (dest[1] != '\0'){
    determiner_indices(dest,N,i_dest,j_dest);
    if (*i_dest>=0 && *i_dest<N && *j_dest>=0 && *j_dest<N && nb>nb_de_piece(tableau[*i_dest][*j_dest],"BN"[(*tour+1)%2])){
      pile tmp=tableau[i_src][j_src];
      int valide,i;
      
      for (i=0 ; i<nb ; i++){
        switch (tmp->chaine[0]){
          case 'P' :
            valide=pions(tableau,N,i_src,j_src,*i_dest,*j_dest,*tour);
            break;
          case 'R' :
            valide=roi(i_src,j_src,*i_dest,*j_dest);
            break;
          case 'D' :
            valide=dames(tableau,i_src,j_src,*i_dest,*j_dest);
            break;
          case 'T' :
            valide=tours(tableau,i_src,j_src,*i_dest,*j_dest);
            break;
          case 'F' :
            valide=fous(tableau,i_src,j_src,*i_dest,*j_dest);
            break;
          case 'C' :
            valide=cavaliers(tableau,i_src,j_src,*i_dest,*j_dest);
            break;
          default :
            valide=0;
        }
        if (! valide)
          break;
        tmp=tmp->next;
      }
      if (nb_de_cavaliers(tableau[i_src][j_src],"BN"[*tour%2],nb)*2>=nb){
        valide=cavaliers(tableau,i_src,j_src,*i_dest,*j_dest);
      }
      if (valide){
        effectuer(tableau,N,i_src,j_src,*i_dest,*j_dest,nb,*tour);
        *tour=*tour+1;
      } else {
        printf("Déplacement illégal pour au moins un pion de la pile");
      }
    } else if (*i_dest>=0 && *i_dest<N && *j_dest>=0) {
      printf("Coordonnées invalides pour la case de destination");
    } else if (*j_dest<N && nb>nb_de_piece(tableau[*i_dest][*j_dest],"BN"[(*tour+1)%2])){
      printf("Le nombre de pions à déplacer doit être strictement plus grand que le nombre de pions adverses sur la case de destination");
    }
  }
}

int pions(pile **tableau,int N,int i_src,int j_src,int i_dest,int j_dest,int tour)
{
  int k=0;
  if ("BN"[tour%2] == 'N'){
    k=1;
  } else {
    k=-1;
  }
  if (nb_de_piece(tableau[i_dest][j_dest],"BN"[(tour+1)%2])==0 && j_dest==j_src){
    if (i_dest==i_src+k)
      return 1;
    if (i_dest==i_src+k+k && longueur_pile(tableau[i_src+k][j_src])==0){
      if (k<0 && i_src==N-2) return 1;
      else if (k>0 && i_src==1) return 1;
    }
  } else if (i_dest==i_src+k && (j_dest==j_src+1 || j_dest==j_src-1)){
    return 1;
  }
  return 0;
}

int dames(pile ** tableau,int i_src,int j_src,int i_dest,int j_dest)
{
  if ((j_dest==j_src && i_dest!=i_src) || (i_dest==i_src && j_dest!=j_src)){
    return tours(tableau,i_src,j_src,i_dest,j_dest);
  }
  
  if (abs(i_dest-i_src)==abs(j_dest-j_src) && i_dest!=i_src){
    return fous(tableau,i_src,j_src,i_dest,j_dest);
  }
  
  return 0;
}

int roi(int i_src,int j_src,int i_dest,int j_dest)
{
  if (i_dest==i_src)
    if (j_dest==j_src-1 || j_dest==j_src+1)
      return 1;
  if (i_dest==i_src+1 || i_dest==i_src-1)
    if (j_dest==j_src+1 || j_dest==j_src || j_dest==j_src-1)
      return 1;
  return 0;
}
int tours(pile **tableau,int i_src,int j_src,int i_dest,int j_dest)
{
  int k;
  if (j_dest==j_src && i_dest!=i_src){
    for (k=1;k<abs(i_dest-i_src);k++){
      if (i_dest>i_src){
        if (longueur_pile(tableau[i_src+k][j_src])!=0){
          return 0;
          break;
        }
      } else {
        if (longueur_pile(tableau[i_src-k][j_src])!=0){
          return 0;
          break;
        }
      }
    }
    return 1;
  }
  if (i_dest==i_src && j_dest!=j_src){
    for (k=1;k<abs(j_dest-j_src);k++){
      if (j_dest>j_src){
        if (longueur_pile(tableau[i_src][j_src+k])!=0){
          return 0;
          break;
        }
      } else {
        if (longueur_pile(tableau[i_src][j_src-k])!=0){
          return 0;
          break;
        }
      }
    }
    return 1;
  }
  return 0;
}

int fous(pile** tableau,int i_src,int j_src,int i_dest, int j_dest)
{
  int k;
  if (abs(i_dest-i_src)==abs(j_dest-j_src) && i_dest!=i_src){
    for (k=1;k<abs(i_dest-i_src);k++){
      if (j_dest>j_src){
        if (i_dest>i_src){
          if (longueur_pile(tableau[i_src+k][j_src+k])!=0){
            return 0;
            break;
          }
        } else {
          if (longueur_pile(tableau[i_src-k][j_src+k])!=0){
            return 0;
            break;
          }
        }
      } else {
        if (i_dest>i_src){
          if (longueur_pile(tableau[i_src+k][j_src-k])!=0){
            return 0;
            break;
          }
        } else {
          if (longueur_pile(tableau[i_src-k][j_src-k])!=0){
            return 0;
            break;
          }
        }
      }
    }
    return 1;
  }
  return 0;
}

int cavaliers(pile **tableau,int i_src,int j_src,int i_dest,int j_dest)
{
  if ((i_dest==i_src+2 && longueur_pile(tableau[i_src+1][j_src])==0 && longueur_pile(tableau[i_src+2][j_src])==0) || (i_dest==i_src-2 && longueur_pile(tableau[i_src-1][j_src])==0 && longueur_pile(tableau[i_src-1][j_src])==0)){
    if (j_dest==j_src+1 || j_dest==j_src-1) return 1;
  } else if ((j_dest==j_src+2 && longueur_pile(tableau[i_src][j_src+1])==0 && longueur_pile(tableau[i_src][j_src+2])==0) || (j_dest==j_src-2 && longueur_pile(tableau[i_src][j_src-1])==0 && longueur_pile(tableau[i_src][j_src-2])==0)){
    if (i_dest==i_src+1 || i_dest==i_src-1) return 1;
  }
  return 0;
}

void effectuer(pile **tableau,int N,int i_src,int j_src, int i_dest,int j_dest,int nb,int tour)
{
  pile p;
  int i;
  for (i=0 ; i<nb ; i++){
    empiler(&p,depiler(tableau[i_src]+j_src));
  }
  if (sommet(tableau[i_dest][j_dest])[0]=="BN"[(tour+1)%2])
    //réalise une attaque
    reset(tableau[i_dest]+j_dest);
  for (i=0 ; i<nb ; i++){
    empiler(tableau[i_dest]+j_dest,depiler(&p));
    if (sommet(tableau[i_dest][j_dest])[0]=='P' && (i_dest==N-1 || i_dest==0)) {
      //transforme les pions en dames
      depiler(tableau[i_dest]+j_dest);
      if (tour%2==0) empiler(tableau[i_dest]+j_dest,"DB");
      else empiler(tableau[i_dest]+j_dest,"DN");
    }
  }
}
