#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#include"tableau.h"
/*tableau.c*/

pile **initialisation(int N)
{
  int i,j;
  pile ** tableau;
  tableau = (pile**) malloc(N*sizeof(pile*));
  for (i=0 ; i<N ; i++){
    tableau[i] =(pile*)malloc(N*sizeof(pile));
    for (j=0 ; j<N ; j++)
      tableau[i][j] = NULL;
  }
  return tableau;
}

int est_vide(pile p)
{
  return p == NULL;
}

char *sommet(pile p)
{
  if (!est_vide(p)) return p->chaine;
  else return "\0";
} 


void empiler(pile *p, char *elt)
{
  pile nouveau;
  nouveau = (pile) malloc(sizeof(struct _noeud));
  nouveau->chaine = elt;
  nouveau->next = *p;
  *p = nouveau;
}

char *depiler(pile *p)
{
  if (! est_vide(*p)){
    char *elt;
    elt = (*p)->chaine;
    pile tmp = *p;
    *p = (*p)->next;
    free(tmp);
    return elt;
  }
  return NULL;
}

void reset(pile *p)
{
  while (! est_vide(*p))
    /*termine lorsque p n'a plus de sommet à dépiler (car p est de longueur finie)*/
    depiler(p);
}

void nettoyer(pile **tableau,int N)
{
  int i,j;
  for (i=0 ; i<N ; i++)
    for (j=0 ; j<N ; j++)
      reset(&(tableau[i][j]));
  for (i=0 ; i<N ; i++)
    free(tableau[i]);
  free(tableau);
  
}

void debut_partie(pile **tableau, int N)
{
  int j;
  empiler(tableau[0]+N/2-1,"DN");
  empiler(tableau[0]+N/2,"RN");
  empiler(tableau[N-1]+N/2-1,"DB");
  empiler(tableau[N-1]+N/2,"RB");
  for (j=0 ; j<N ; j++){
    empiler(tableau[1]+j,"PN");
    empiler(tableau[N-2]+j,"PB");
    if (j != N/2-1 && j != N/2){
      if (j%3 == 0){
        empiler(tableau[0]+j,"FN");
        empiler(tableau[N-1]+j,"FB");
      } else if (j%3 == 1) {
        empiler(tableau[0]+j,"TN");
        empiler(tableau[N-1]+j,"TB");
      } else {
        empiler(tableau[0]+j,"CN");
        empiler(tableau[N-1]+j,"CB");
      }
    }
  }
}

int longueur_pile(pile p)
{ 
  int i=0;
  while (p != NULL){
    /*termine quand on arrive au bout de la pile qui est de longueur finie*/
    i++;
    p=p->next;
  }
  return i;
}


void determiner_indices(char *sel,int N,int *i,int *j)
{
  *j=*sel-'A';
  *i=N-strtol(sel+1,NULL,10);
}

int nb_de_piece(pile p,char couleur)
{
  int i=0;
  while (p != NULL){
    /*termine car la pile est de longueur finie*/
    if (p->chaine[1]==couleur) i++;
    p=p->next;
  }
  return i;
}

int nb_de_cavaliers(pile p,char couleur,int nb)
{
  int i,k=0;
  for (i=0 ; i<nb ; i++){
    if (p->chaine[0] == 'C' && p->chaine[1]==couleur) k++;
    p=p->next;
  }
  return k;
}

int partie_finie(pile ** tableau,int N,int tour)
{
  tour=tour-1;
  int i,j,k=0,l=0,toursb=0,toursn=0,fousb=0,fousn=0;
  for (i=0 ; i<N ; i++){
    for (j=0; j<N ; j++){
      k=k+nb_de_piece(tableau[i][j],"BN"[(tour+1)%2]);
      l=l+nb_de_piece(tableau[i][j],"BN"[tour%2]);
    }  
  }
  
  if (k==0){
    /*le cas où on a pris toutes les pièces de l'adversaire*/
    printf("La partie est finie\n les %c ont gagné !\n","BN"[tour%2]);
    return 1;
  
  } else if (k+l==2){
    /*le cas où il ne reste que 2 pièces sur le plateau*/
    printf("On a un cas d'égalité !");
    return 1;
  }
  pile tmp;
  if (k+l==4){
    /*le cas il reste à chacun un fou et une tour*/
    for (i=0 ; i<N ; i++){
      for (j=0 ; j<N ; j++){
        tmp=tableau[i][j];
        while (tmp != NULL){
          if (tmp->chaine[0]=='T'){
            if (tmp->chaine[1]=='B') toursb+=1;
            else toursn+=1;
          }
          if (tmp->chaine[0]=='F'){
            if (tmp->chaine[1]=='B') fousb+=1;
            else fousn+=1;
          }
          tmp=tmp->next;
        }
      }
    }
    if (toursb==1 && toursn==1 && fousb==1 && fousn==1){
      printf("On a un cas d'égalité !");
      return 1;
    }
  }
  return 0;
}