
#ifndef _TABLEAU
#define _TABLEAU

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
/*tableau.h*/


typedef struct _noeud * pile;
struct _noeud{char *chaine;pile next;};

/*
 @require 
 @assign alloue un tableau de taille N*N
 @ensure renvoie un tableau alloué de taille N*N dont les cases sont des piles 
*/
pile **initialisation(int N);

/*
 @require
 @assign
 @ensure retourne 1 si la pile est vide 0 sinon
*/
int est_vide(pile p);

/*
 @require
 @assign
 @ensure retourne la valeur du sommet de la pile 
*/
char *sommet(pile p);

/*
 @require elt doit être de taille 2
 @assign alloue un nouveau pointeur vers une structure noeud 
 @empile empile un pion sur une case du plateau 
*/
void empiler(pile *p, char *elt);

/*
 * @require la pile à dépiler doit être non vide
 * @assign
 * @ensure enlève le sommet de la pile p et le retourne
*/
char *depiler(pile *p);

/*
 * @require
 * @assign
 * @ensure remet une pile à zero
*/
void reset(pile *p);

/*
 * @require le tableau est supposé être passé par la fonction initialisation() 
 * @assign
 * @ensure nettoie la mémoire allouée au tableau 
*/
void nettoyer(pile **tableau,int N);

/*
 * @require 
 * @assign
 * @ensure posent les pions sur le plateau en debut de partie
 */
void debut_partie(pile **tableau,int N);

/*
 * @require
 * @assign
 * @ensure retourne le nombre d'éléments dans une pile 
 */
int longueur_pile(pile p);

/*
 * @require 
 * @assign
 * @ensure retourne une tuple contenant les indices de la case selectionnée à partir des coordonnées rentrées à la main
 */
void determiner_indices(char *sel,int N,int *i,int *j);

/*
 * @require
 * @assign
 * @ensure retourne le nombre de pion d'une couleur donnée placés sur le haut de la pile/case
 */
int nb_de_piece(pile p,char couleur);

/*
 * @require
 * @assign
 * @ensure retourne le nombre de cavalier d'une couleur donnée dans la pile
 */
int nb_de_cavaliers(pile p,char couleur,int nb);

/*
 * @require
 * @assign
 * @ensure retourne 1 si la partie est finie, 0 sinon
 */
int partie_finie(pile ** tableau, int N,int tour);
#endif 

